// HelloWin32.cpp
// compile with: /D_UNICODE /DUNICODE /DWIN32 /D_WINDOWS /c

#include <windows.h>       // Search along the path.
#include <stdlib.h>        // Search along the path.
#include <tchar.h>         // Search along the path.
#include <stdio.h>         // Search along the path.

#include <iostream>        // Search along the path.
#include <string.h>        // Search along the path.
using namespace std;

#include "zTrace.h"        // Search in the same directory of the current file.
#include "WinLIFT.h"       // Search in the same directory of the current file.

#define MyWindowWidth      800
#define MyWindowHeight     614


#define IDC_MAIN_CLOCK     1004
#define IDC_MAIN_KNOBLEFT  1005
#define IDC_MAIN_KNOBBIG   1006
#define IDC_MAIN_KNOBRIGHT 1007
#define IDC_MAIN_LOADIMAGE 1008
#define IDC_MAIN_STATICIMG 1009

// Global variables
HINSTANCE g_hInst;        // Current instance

// Declaration of the functions being used in this module:
//INT_PTR CALLBACK About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
string FullExeName();
string ExePath();

int WINAPI wWinMain(HINSTANCE hInstance, 
                    HINSTANCE hPrevInstance, 
                    LPTSTR lpCmdLine, 
                    int nCmdShow)
{
    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);

    // Declaration of local variables
    MSG msg;
    int nRet = 0;
    int IsInitialized = 0;
    WNDCLASSEX wcx;
    TCHAR szWindowClass[] = _T("win32app");
    TCHAR szTitle[] = _T("Win32 Guided Tour Application");

    // Register the main window class
    wcx.cbSize = sizeof(WNDCLASSEX);
    IsInitialized = GetClassInfoEx(hInstance, szWindowClass, &wcx);
    if (!IsInitialized)
    {
        wcx.style         = CS_HREDRAW | CS_VREDRAW;
        wcx.lpfnWndProc   = WndProc;
        wcx.cbClsExtra    = 0;
        wcx.cbWndExtra    = 0;
        wcx.hInstance     = hInstance;
        wcx.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
        wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
        wcx.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
        wcx.lpszMenuName  = NULL;
        wcx.lpszClassName = szWindowClass;
        wcx.hIconSm       = LoadIcon(wcx.hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
        if (RegisterClassEx(&wcx))
        {
           IsInitialized = -1;
        }
     }

     if (IsInitialized)
     {
        g_hInst = hInstance; // Stocke le handle d'instance dans la variable globale
    

        int w = MyWindowWidth;
        int h = MyWindowHeight;
        int x = max((GetSystemMetrics(SM_CXSCREEN) - w) / 2, 0);
        int y = max((GetSystemMetrics(SM_CYSCREEN) - h) / 2, 0);

        DWORD dwStyle = WS_POPUP | WS_THICKFRAME | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX |
                        WS_MAXIMIZEBOX | WS_CLIPSIBLINGS | WS_CLIPCHILDREN; // | WS_VISIBLE

        HWND hWnd = CreateWindowEx(
                    0,                              // Optional window styles.
                    szWindowClass,                  // Window class
                    szTitle,                        // Window text
                    dwStyle,                        // Window style
    
                    // Size and position
                    x, y, w, h,
    
                    NULL,       // Parent window    
                    NULL,       // Menu
                    hInstance,  // Instance handle
                    NULL        // Additional application data
                    );
    
        if (hWnd)
        {

            //char szMsg[] = "hello";
            //zTrace(szMsg);

            //string Msg = "Window";
            //char szStr[12];
            //sprintf_s(szStr, "% d ", hWnd);
            //Msg += szStr;
            //zTrace(Msg);

            //char exepath[MAX_PATH]; 
            //int LenExeName = GetModuleFileNameA(0, exepath, sizeof(exepath)); 
            //zTrace(exepath);

            string SkinTheme = ExePath();
            SkinTheme += "Sony.sks";
            //SkinTheme += "Naavi.sks";
            if (skInitEngine (SkinTheme, ""))
            {
                skSkinWindow(hWnd, "Dock|Undock|Minimize|Maximize|Restore|Close");

                string sResourcePath = ExePath();
                sResourcePath += "Resource\\";

                // Add a clock control.
                string sResource = sResourcePath;
                sResource += "Clock_09_92.png";
                HWND hCtrl = skClockCtrl(hWnd, sResource, 4, 476, 0, 0, IDC_MAIN_CLOCK, 0x7FCB0000, 0x7F8F8F8F, 0);
                skSetAnchorCtrl(hCtrl, ANCHOR_BOTTOM);          // Anchor control
                skCreateToolTip(hCtrl, "WinLIFT clock widget"); // Add tooltip.

                // Add a 5-state button image.
                sResource = sResourcePath;
                sResource += "SelectImage.png";
                hCtrl = skButtonImage(hWnd, sResource, 780 - 58, 498, IDC_MAIN_LOADIMAGE, 5);
                skSetAnchorCtrl(hCtrl, ANCHOR_BOTTOM_RIGHT);
                skCreateToolTip(hCtrl, "WinLIFT ButtonImage");

                // Add two circular slider gauges.
                sResource = sResourcePath;
                sResource += "BTN_Gauge01.png";
                hCtrl = skKnobGauge(hWnd, sResource, 303, 527, 0, 0, IDC_MAIN_KNOBLEFT, 0, 0, 0, 0);
                skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);
                skCreateToolTip(hCtrl, "WinLIFT KnobGauge");
                hCtrl = skKnobGauge(hWnd, sResource, 436, 527, 0, 0, IDC_MAIN_KNOBRIGHT, 0, 0, 0, 0);
                skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);
                skCreateToolTip(hCtrl, "WinLIFT KnobGauge");

                // Add a circular slider gauge.
                sResource = sResourcePath;
                sResource += "BTN_Gauge02.png";
                hCtrl = skKnobGauge(hWnd, sResource, 344, 476, 0, 0, IDC_MAIN_KNOBBIG, 0, 0, 0, 0);
                skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);
                skCreateToolTip(hCtrl, "WinLIFT KnobGauge");

//skGaugeSetMinMax(hCtrl, 100, 200);
//int nMin = 0, nMax = 0;
//skGaugeGetMinMax(hCtrl, nMin, nMax);
//string Msg;
//char szStr[12];
//sprintf_s(szStr, "% d ", nMin);
//Msg += szStr;
//sprintf_s(szStr, "% d ", nMax);
//Msg += szStr;
//zTrace(Msg);
//Msg = skGetToolTipText(hCtrl);
//Msg += skVersion();
//Msg = skSkinFolder();
//zTrace(Msg);
                sResource = sResourcePath;
                sResource += "Assistant.png";
                hCtrl = skStaticImage (hWnd, sResource, 580, 20, 185, 456, IDC_MAIN_STATICIMG);   
                skSetAnchorCtrl(hCtrl, ANCHOR_HEIGHT_RIGHT);
            }

            ShowWindow(hWnd, nCmdShow);
            UpdateWindow(hWnd);
    
            // Main message loop
            while (GetMessage(&msg, NULL, 0, 0))
            {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
            nRet = msg.wParam;
        }
     }
    
     return nRet;
}

// Main winproc
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

    switch (uMsg)
    {
    case WM_COMMAND:
         wmId    = LOWORD(wParam);
         wmEvent = HIWORD(wParam);
         // Process menu command
         //switch (wmId)
         //{
         //case IDM_ABOUT:
         //     DialogBox(g_hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
         //     break;
         //case IDM_EXIT:
         //     DestroyWindow(hWnd);
         //     break;
         //}
         return 0;
    case WM_PAINT:
         hdc = BeginPaint(hWnd, &ps);
         // TODO: process here the WM_PAINT message...
         EndPaint(hWnd, &ps);
         return 0;
    case WM_DESTROY:
         PostQuitMessage(0);
         return 0;
    }
   
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}  

string FullExeName()
{
    string sResult;
    char exepath[MAX_PATH]; 
    if (GetModuleFileNameA(0, exepath, sizeof(exepath)))
    {
        sResult = exepath;
    }
    return sResult;
}

string ExePath()
{
    string sResult;
    char exepath[MAX_PATH]; 
    if (GetModuleFileNameA(0, exepath, sizeof(exepath)))
    {
        sResult = exepath;
        sResult = sResult.substr( 0, sResult.rfind("\\"));
        sResult += "\\";
    }
    return sResult;
}

//// The about dialog function
//INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
//{
//    UNREFERENCED_PARAMETER(lParam);
//    switch (message)
//    {
//    case WM_INITDIALOG:
//         return (INT_PTR)TRUE;
//
//    case WM_COMMAND:
//         if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
//         {
//            EndDialog(hDlg, LOWORD(wParam));
//            return (INT_PTR)TRUE;
//         }
//         break;
//    }
//    return (INT_PTR)FALSE;
//}

